% \documentclass[noanswers, nolegalese, 11pt]{examjh}
\documentclass[answers, nolegalese]{examjh}
\usepackage{../../../computingfonts}
\usepackage{../../../contentmacros}

\setlength{\parindent}{0em}\setlength{\parskip}{0.5ex}
\begin{document}\thispagestyle{empty}
\makebox[\textwidth]{\sc MA 208, Theory of Computation\hfill Weekly Hand-in\hfill Due: 2022-Feb-13}
\vspace*{1ex}
\begin{center}
 \parbox{0.95\textwidth}{\textit{
  The work that you hand in must be entirely your own. 
  When you write this document, you may not work with anyone else,
  or copy material from the Internet, etc.
  You are of course allowed to use the text, the videos, or the notes
  or discussions from class.
  }}
\end{center}
\vspace*{1ex}
\begin{questions}
\question
Suppose that a Turing machine that implements this behavior has index~$e$.
\begin{equation*}
  f(x_0,x_1)=
  \begin{cases}
    2x_1  &\case{if $x_0$ is even}  \\
    x_1^2+x_0 &\case{otherwise} 
  \end{cases}
  \tag{*}
\end{equation*}
\begin{parts}
\part
What are the values of 
$\TMfcn_{s(e,0)}(4)$,
$\TMfcn_{s(e,0)}(5)$,
and
$\TMfcn_{s(e,0)}(6)$?
\begin{solution}
They are $\TMfcn_{s(e,0)}(4)=8$, 
$\TMfcn_{s(e,0)}(5)=10$,
and
$\TMfcn_{s(e,0)}(6)=12$.
\end{solution}

\part
What are the values of 
$\TMfcn_{s(e,1)}(4)$,
$\TMfcn_{s(e,1)}(5)$,
and
$\TMfcn_{s(e,1)}(6)$?
\begin{solution}
They are 
$\TMfcn_{s(e,1)}(4)=17$,
$\TMfcn_{s(e,1)}(5)=26$,
and
$\TMfcn_{s(e,1)}(6)37$.
\end{solution}

\part
Describe (as in equation~($*$))
the function $\TMfcn_{s(e,5)}(y)$.
\begin{solution}
It is $\TMfcn_{s(e,5)}(y)=y^2+5$.
\end{solution}

\part
Use flowcharts to sketch the computation of first four
members of the family $\TMfcn_{s(e,x)}$, that is,
where $x=0, \ldots$\ $x=3$. 
\begin{solution}
Note that the flowcharts for even $x$'s are different than the ones
for odd~$x$'s.
\vspace*{1ex}
\begin{center}
  \begin{tabular}{*{4}{rc@{\hspace{1.5em}}}}
  $P_{s(e,0)}$: &\vcenteredhbox{\includegraphics{asy/flowcharts000.pdf}}
  &$P_{s(e,1)}$: &\vcenteredhbox{\includegraphics{asy/flowcharts001.pdf}}
  &$P_{s(e,2)}$: &\vcenteredhbox{\includegraphics{asy/flowcharts002.pdf}}
  &$P_{s(e,3)}$: &\vcenteredhbox{\includegraphics{asy/flowcharts003.pdf}}
  \end{tabular}
\end{center}

\end{solution}
\end{parts}

\end{questions}
\end{document}